/*---------------------------------------------------------------*/
/*     	CAPSS: A Cartesian Parallel Sparse Solver                */
/*     	Beta Release                                             */
/*      Author: Padma Raghavan                                   */
/*---------------------------------------------------------------*/
#include	"n_merges.h"
merge_matrices_spd( current,
		tree_child,
		tree_sibling,
		chain, 	
		chain_index,
		index_list)

				
int		current,
		*tree_child,
		*tree_sibling,

		*chain, 	
		*chain_index,


		*index_list;



{

		
		int		current_size,	child;

	


			

		set_up_spd_mat(	current,
				index_list);
				

		for(child = tree_child[current]; child!= -1; )      
		{
			add_and_free_spd_mat (	current,
					child,
					index_list);
			child = tree_sibling[child] ;

		}

		
		if (tree_child[current] != -1)
		move_over_spd_mat(	current,
				tree_child[current],	
				
				index_list);

		add_nonz_of_A_spd(	current,
				index_list,
				(chain_index + current),
				(chain + chain_index[current]),
				(chain_index[current+1] 
				- chain_index[current]),
          			(tree_local_column + 
					chain_index[current]));

}/*end merge_matrices*/	
set_up_spd_mat(	current,
		index_list)

int		current,
		*index_list;

{

		int 	col,	current_size, *factor_struc_ptr,
			extra,
			next, 	*ptr_to_parent,	tmp_store_size;
		double  *tmp_store;
		extern		char	*malloc();
	

				

		if ((stack_ptr + factor_struc_sizes[current]) >
				max_stack_columns) {
		exit_err("stack_overflow",int_err3);
		}
		index_list[current] = stack_ptr;
		tmp_store_size = factor_struc_sizes[current] ;
		tmp_store_size = tmp_store_size  * (tmp_store_size +1);
		tmp_store_size = (int) (tmp_store_size/2) + 1;
		extra = tmp_store_size * double_size;
		if (( tmp_store = (double *) malloc ((extra))) 
			== NULL)
			exit_err("columnof l - tmp_store", malloc_err);
		extra = factor_struc_sizes[current] * int_size;
		if (( ptr_to_parent_factorstruc[current] = 
			(int *) malloc (( extra)))
				== NULL)
				exit_err("ptr_to_parent", malloc_err);

		for (col=0, next= stack_ptr, 
			factor_struc_ptr = factor_struc[current],
			ptr_to_parent = ptr_to_parent_factorstruc[current],
				current_size = factor_struc_sizes[current]; 
				col < current_size;
					col++) {
			
			stack_nonz_sizes[next] = current_size - col;
			stack_nonz[next] = tmp_store;
			tmp_store += current_size -col;
			tmp_store_size -= current_size -col;
			ptr_to_parent[col] = -1;
			zero_out(stack_nonz[next], (current_size-col));

			next++;
		}
		index_list[current+1] =stack_ptr= next; 
		if ( tmp_store_size <= 0) {
			exit_err("error in tmp_store - set_up",int_err3);
		}


}/*set_up_spd_mat*/
		
move_over_spd_mat(	current,
		child,	
		index_list)

int		current,
		child,
		*index_list;

{

		int *factor_struc_ptr,	col,	current_size,	next, later;

                if ((index_list[child] + factor_struc_sizes[current]) >
                                max_stack_columns) {
			exit_err("stack_overflow",int_err3);
                }

		for (col=0,next= index_list[child],
				 factor_struc_ptr = factor_struc[current],
				current_size = factor_struc_sizes[current],
				later = index_list[current];
				col < current_size;
					col++) {
			if ( later != next) {
			stack_nonz_sizes[next] = stack_nonz_sizes[later];
			stack_nonz[next] = stack_nonz[later] ;
			stack_nonz[later] = NULL;
			stack_nonz_sizes[later] =0;
			next++; later++;
			}
			
		}
		index_list[current] = index_list[child]; 
		index_list[current+1] = index_list[current] + current_size;
		stack_ptr = index_list[current+1];
}/*move over */
add_and_free_spd_mat (
	      	current,
		child,
		index_list)

int	
	      	current,
		child,
		*index_list;
{

		int	this,	this_nonz,	this_size, 	*this_struc,
			next,	child_nonz,	child_size,	*child_struc;
		int	*ptr_to_parent;
		
		for (this_struc = factor_struc[current], 
			ptr_to_parent= ptr_to_parent_factorstruc[child],
				this_size = factor_struc_sizes[current],
				child_struc = factor_struc[child],
				child_size  = factor_struc_sizes[child],
				this_nonz = index_list[current],
				child_nonz= index_list[child],
				next = this=0;
				next < child_size;) {
			if (child_struc[next] == this_struc[this]) {
					copy_expand(ADD,
					           this_struc[this],
							
						   (this_struc + this),
						    stack_nonz[this_nonz],
						    stack_nonz_sizes[this_nonz],
						
						   (child_struc + next),	
						   stack_nonz[child_nonz],
					   stack_nonz_sizes[child_nonz]);
					

					ptr_to_parent[next] = this;

					stack_nonz_sizes[child_nonz] =0;

					this++; next++;this_nonz++;child_nonz++;
				}
				else if (child_struc[next] > this_struc[this]) { 
					this++; 
					this_nonz++;
					}
					else { next++;
						child_nonz++;
						}

		}							
if ( stack_nonz[index_list[child]] != NULL) {
			free ((char *) stack_nonz[index_list[child]]);
			stack_nonz[index_list[child]] = NULL;
}

}/*add_and_free_mat*/


add_nonz_of_A_spd(	current,
		index_list,
		chain_index,
		chain,
		chain_size, local_column)

int		current,
		*index_list,
		*chain_index,
		*chain,
		chain_size, *local_column;
{

		int	col,	*factor_struc_ptr, this_nonz,
			local_column_of_A;


		for (col=0, 
			factor_struc_ptr = factor_struc[current],
			this_nonz = index_list[current];
					 col < chain_size; col++,
						this_nonz++) {
				local_column_of_A= local_column[col];
				if (local_column_of_A != EMPTY) {
				copy_expand_flt(ADD,
					    factor_struc_ptr[col],

					    (factor_struc_ptr + col), 
					    stack_nonz[this_nonz],
					    stack_nonz_sizes[this_nonz],
						
					   (a_struc+ a_index
							[local_column_of_A]),	
					   (a_nonz+ a_index
							[local_column_of_A]),	
					   a_size[local_column_of_A]);	
					   
				} else {
				printf("%d:empty local col current %d\n",
					me, local_column_of_A);
				exit_err("empty_local_col",case_err);
				}
					
				

		}

}/*end add_nonz_ofA*/

merge_rhs_spd( current,
		tree_child,
		tree_sibling,
		chain, 	
		chain_index,
		index_list)

				
int		current,
		*tree_child,
		*tree_sibling,

		*chain, 	
		*chain_index,


		*index_list;



{

		
		int		current_size,	child;

	


			

		set_up_spd_rhs(	current,
				index_list);
				

		for(child = tree_child[current]; child!= -1; )      
		{
			add_and_free_spd_rhs (	current,
					child,
					index_list);
			child = tree_sibling[child] ;

		}

		
		if (tree_child[current] != -1)
		move_over_spd_rhs(	current,
				tree_child[current],	
				
				index_list);

		add_nonz_of_rhs_spd(	current,
				index_list,
				(chain_index + current),
				(chain + chain_index[current]),
				(chain_index[current+1] 
				- chain_index[current]),
          			(tree_local_column + 
					chain_index[current]));

}/*end merge_matrices*/	
set_up_spd_rhs(	current,
		index_list)

int		current,
		*index_list;

{

		int 	col,	current_size,
			next;
		extern		char	*malloc();
	

				

		index_list[current] = stack_ptr;
		for (col=0, next= stack_ptr, 
				current_size = factor_struc_sizes[current]; 
				col < current_size;
					col++) {
			stack_b[next] =0.0;
			next++;
		}
		index_list[current+1] =stack_ptr= next; 


}/*set_up*/
		
move_over_spd_rhs(	current,
		child,	
		index_list)

int		current,
		child,
		*index_list;

{

		int 	col,	current_size,	next, later;


		for (col=0,next= index_list[child],
				current_size = factor_struc_sizes[current],
				later = index_list[current];
				(col < current_size); col++) {
			if ( later != next) {
			stack_b[next]   = stack_b[later];
			stack_b[later] = 0.0;
			next++; later++;
			}
			
		}
		index_list[current] = index_list[child]; 
		index_list[current+1] = index_list[current] + current_size;
		stack_ptr = index_list[current+1];
}/*move over */
add_and_free_spd_rhs (
	      	current,
		child,
		index_list)

int	
	      	current,
		child,
		*index_list;
{

		int	this,	this_nonz,	this_size, 	*this_struc,
			next,	child_nonz,	child_size,	*child_struc;
		
		for (this_struc = factor_struc[current], 
				this_size = factor_struc_sizes[current],
				child_struc = factor_struc[child],
				child_size  = factor_struc_sizes[child],
				this_nonz = index_list[current],
				child_nonz= index_list[child],
				next = this=0;
				next < child_size;) {
				if (child_struc[next] == this_struc[this]) {
					stack_b[this_nonz]+= 
						stack_b[child_nonz];
					
					stack_b[child_nonz] =0.0;
					this++; next++;this_nonz++;child_nonz++;
				}
				else if (child_struc[next] > this_struc[this]) { 
					this++; 
					this_nonz++;
					}
					else { next++;
						child_nonz++;
						}

		}							
}/*add_and_free_rhs*/


add_nonz_of_rhs_spd(	current,
		index_list,
		chain_index,
		chain,
		chain_size, local_column)

int		current,
		*index_list,
		*chain_index,
		*chain,
		chain_size, *local_column;
{

		int	col,	this_nonz, local_column_of_A;


		for (col=0, this_nonz = index_list[current];
					 col < chain_size; col++,
						this_nonz++) {
				local_column_of_A= local_column[col];
				if (local_column_of_A != EMPTY) {
				stack_b[this_nonz] += b[local_column_of_A];
				} else {
				printf("%d:empty local col current %d\n",
					me, local_column_of_A);
				exit_err("empty_local_col",case_err);
				}
					
				

		}

}/*end add_nonz_of_rhs*/


