/*---------------------------------------------------------------*/
/*     	CAPSS: A Cartesian Parallel Sparse Solver                */
/*     	Beta Release                                             */
/*      Author: Padma Raghavan                                   */
/*---------------------------------------------------------------*/
#include	"o_d_l_glue.h"
re_set_up_lists()
{
		extern	double clock0(), stats[], my_time;
		double last_clock;
		int dim;

		last_clock = clock0();
		d_phase =0;
		re_make_items();
		re_initialize_lists();

		last_used_in_scratch_list = max_size_d_scratch_list =0;
		max_size_scratch_list = (1.5)*max_size_kappa_counts[0];
		max_size_scratch_list =  5*Asubs;
                if((scratch_list = 
			(int *) my_malloc((max_size_scratch_list*
				int_size))) == NULL)
                         exit_err("main_scratch_list", malloc_err);
		if ((end_numbers[0] - start_numbers[0])>=0) l_phase=1;
		stats[r_t] += clock0() - last_clock;
 		for (dim=0; ((1<< dim) < Asubs); )
                                 	dim++;
		stats[r_o] +=  (D* Asubs + D*my_N) *dim;
		stats[r_o] /= Million;
}/*end re_set_up_lists */

re_make_items()
{

		extern	double clock0(), my_time;
		int	dim,
			*tmp_list1, *tmp_list2, *tmp_list3, *tmp_list4,i, j ;
	

		if((tmp_list1 = (int *) my_malloc((2*Asubs*int_size))) == NULL)
			exit_err("re_make_items:tmp_list1", malloc_err);
		if((tmp_list2 = (int *) my_malloc((2*Asubs*int_size))) == NULL)
			exit_err("re_make_items:tmp_list2", malloc_err);
		if((tmp_list3 = (int *) my_malloc((2*Asubs*int_size))) == NULL)
			exit_err("re_make_items:tmp_list3", malloc_err);
		if((tmp_list4 = (int *) my_malloc((2*Asubs*int_size))) == NULL)
			exit_err("re_make_items:tmp_list4", malloc_err);
		quick_sort(my_N,tmp_list3,global_column);	
		inverse_perm(my_N, tmp_list4, tmp_list3);
		permute(my_N,1,tmp_list4,global_column,NULL);
		permute(my_N,1,tmp_list4,new_numbers, NULL);
		for (dim=0; dim < D; dim++)
			permute(my_N,1,tmp_list4,xyz_int[dim],NULL);
		squeeze_out_etc();


		copy(my_N, 1, global_column, 2, tmp_list3);
		for (i=0, j=1; i <my_N; i++, j+=2)
			tmp_list3[j] = i;

		copy(Asubs, 2, global_row_col, 1, tmp_list1);
		quick_sort(Asubs,tmp_list2,tmp_list1);	
		replace_by_local_cols(0,Asubs, global_row_col, tmp_list2,
				my_N, tmp_list3, row_col);

		copy(Asubs, 2, global_row_col+1, 1, tmp_list1);
		quick_sort(Asubs,tmp_list2,tmp_list1);	
		replace_by_local_cols(1,Asubs, global_row_col, tmp_list2,
				my_N, tmp_list3, row_col);
		move_numbered( tmp_list3, tmp_list4);
	
	

		modify_row_col(Asubs*2, row_col, tmp_list4);
		
		free ((char *) tmp_list4);	
		free ((char *) tmp_list3);	
		quick_sort2(Asubs,tmp_list1,row_col);	
		inverse_perm(Asubs, tmp_list2, tmp_list1);
		free ((char *) tmp_list1);	
		permute(Asubs,2,tmp_list2,global_row_col,NULL);
		permute(Asubs,2,tmp_list2,row_col,NULL);
		permute(Asubs,1,tmp_list2,NULL,a_nonz);
		free ((char *) tmp_list2);	
	
		make_vertex_lists();
		make_edge_lists(row_col, Asubs);
	
}/*re_make_items*/
replace_by_local_cols(		
				offset_g_list,
				count_g_list,
				g_list, 
				o_g_list,
				count_list, 
				list,
				new_list)
int
				offset_g_list,
				count_g_list,
				*g_list, 
				*o_g_list,
				count_list, 
				*list, 
				*new_list;
{

			int i, next, next_g;

			for (i=next=0; ((i < count_g_list) &&
					(next < count_list)); ) {
				next_g = o_g_list[i] ;
				if ( g_list[2*next_g + offset_g_list]
					== list[2*next]) {
					new_list[2*next_g + offset_g_list]
						= list[2*next +1];
					i ++;
				} else if ( g_list[2*next_g + offset_g_list]
					> list[2*next]) next++ ;
					else  {
					printf (
					"%d:gooofy:g%d list %d n_g %d n %d\n",
					my_pid,
					g_list[2*next_g +offset_g_list],
					list[2*next], next_g, next);
					exit_err ("goofy",case_err);
					}
			} 
}/*replace_by_local_cols*/
				

squeeze_out_etc()
{

				 
		int	last_used, next, dim;
		for (last_used=0, next=1;
				next < my_N; next++ ) {
					if (global_column[next] >
						global_column[last_used]) {
					if (next > (last_used+1)){
					last_used ++;
					global_column[last_used] =
							global_column[next];
					new_numbers[last_used] =
							new_numbers[next];
					for (dim=0; dim < D; dim++)
						*(xyz_int[dim] + last_used)
						= *(xyz_int[dim] + next);
					}else if ( next== (last_used+1))
							last_used++;
					}
					else if ((global_column[next]
					== global_column[last_used])
					&& (new_numbers[last_used] == EMPTY)
					&& (new_numbers[next] != EMPTY))
					new_numbers[last_used] =
							new_numbers[next];
					
		}
		N= my_N = last_used+1;
}/*sequeeze_out_etc*/

re_initialize_lists()
{
		int dim, i, j;

		other_lists();

		d_start_number =start_numbers[my_pid];
		d_end_number= end_numbers[my_pid];
		chain_index[tree_size] = last_chain_index;
		check_consist(new_numbers,my_N,
			d_start_number, d_end_number);
		d_tree_size = tree_size;
		d_last_chain_index = last_chain_index;
		if((d_tree_parent = (int *) my_malloc(((2*tree_size+N)*int_size))) 
				== NULL)
			exit_err("copy_and_reset:d_tree_parent", malloc_err);
		copy(tree_size, 1, tree_parent,1, d_tree_parent);	
		if((d_chain_index = (int *) my_malloc(((2*tree_size+N)
						*int_size))) 
				== NULL)
			exit_err("copy_and_reset:d_chain_index", 
						malloc_err);
		copy(tree_size, 1, chain_index,1, d_chain_index);	
		if((d_tree_chains = (int *) my_malloc(((2*last_chain_index+2*N)
							*int_size))) 
				== NULL)
			exit_err("copy_and_reset:d_tree_chains", 
						malloc_err);
		copy(last_chain_index, 1, tree_chains,1, d_tree_chains);	
		if((o_n_d_tree_chains = (int *) my_malloc(((2*last_chain_index+2*N)
							*int_size))) 
				== NULL)
			exit_err("copy_and_reset:d_tree_chains", 
						malloc_err);
		copy(last_chain_index, 1, o_n_tree_chains,1, o_n_d_tree_chains);	
		first_in_d_phase = parent_number;

		if((d_new_numbers = (int *) my_malloc((2*my_N*int_size))) 
				== NULL)
			exit_err("copy_and_reset:d_new_chain", 
						malloc_err);
		copy(my_N, 1, new_numbers,1, d_new_numbers);	

		free_seps_list();
		seps_lists(N, M);

              	start_numbers[0] =d_start_number;
              	end_numbers[0] =d_end_number;
                tree_size= last_chain_index =parent_number=0;
                tree_parent[0] = -1;
		
					
		check_consist(d_new_numbers,my_N,
				start_numbers[0], end_numbers[0]);
		
		real_N = N;
		my_N =N = un_numbered_N;	
		set_to(new_numbers, (un_numbered_N), -1);
		set_to(deleted_v+un_numbered_N, (real_N - un_numbered_N), 1);
                for (dim=0; dim < D; dim++)
                        delete_items_v(deleted_v,
                                limits_v_list[dim],
                                v_list[dim],
                                index_v_list[dim],
                                count_v_list[dim]);

		max_graphs =1;
                for (dim=0; dim < D; dim++) {
                        delete_items_ce2(deleted_v,
                                limits_ce_list_starts[dim],
                                ce_list_starts[dim],
                                index_ce_list_starts[dim],
                                count_ce_list_starts[dim], my_N);
                        delete_items_ce2(deleted_v,
                                limits_ce_list_ends[dim],
                                ce_list_ends[dim],
                                index_ce_list_ends[dim],
                                count_ce_list_ends[dim], my_N);
		}

}/*end re_initialize_lsist*/
                                       

free_d_phase_lists ()
{
		
	max_size_r_vector = 0;
	free(((char *) col_map));
	free(((char *) edge_map));
	free(((char *) start_procs));
	free(((char *) count_procs));
/*
	free(((char *) tree_start_procs));
	free(((char *) tree_count_procs));
	free(((char *) tree_end_procs));
*/
	free(((char *) d_graph_seps_list));
	max_blocks = 0;
}/*free_d_phase_lists */
free_other_lists(max_D)
{
	int	dim;

	for (dim=0; dim <max_D; dim++){

		free (((char *) vtx_counts[dim]));
		free (((char *) kappa_counts[dim]));
	}

	free(((char *) beta_counts));
	free(((char *) eps_counts));
	free(((char *) graph_bounds));
	free(((char *) total_graph_count));
	free(((char *) in_graph_v));
	free(((char *) deleted_v));
	free(((char *) in_graph_ce));
}/*free_other_lists*/
free_seps_list()
{
		free (((char *) sepv_list));
		free (((char *) count_sepv_list));
		free (((char *) index_sepv_list));
		free (((char *) cross_list));
		free (((char *) count_cross_list));
		free (((char *) index_cross_list));
		free (((char *) chain_index));
		free (((char *) tree_chains));
		free (((char *) o_n_tree_chains));
		free (((char *) tree_parent));
		free (((char *) start_numbers));
		free (((char *) end_numbers));
		free (((char *) new_numbers));
		free (((char *) color));
		free (((char *) a_index));
}/*free_seps_lists*/	

check_consist(list,size,  strt, end)
int	*list, strt, end;
{
		int count, i;
		for (count=i=0; i < size; i++)
					if(list[i] == EMPTY) count++;
		if (count != (end-strt +1))
			exit_err("check_consist",int_err2);
}
move_numbered( tmp_list3, tmp_list4)
int 	*tmp_list3, *tmp_list4;
{

		int i, next, dim, last;	
		for (i=next=last=0; i <my_N; i++){
			if (new_numbers[i] == EMPTY) {
				tmp_list3[next++] = i;
			}
		}
		last = next;
		for (i=0; i <my_N; i++){
			if (new_numbers[i] != EMPTY) {
				tmp_list3[next++] = i;
			}
		}
		copy(my_N, 1, global_column, 1, tmp_list4);
		replace(global_column, my_N, tmp_list3, tmp_list4, next);

		copy(my_N, 1, new_numbers, 1, tmp_list4);
		replace(new_numbers, my_N, tmp_list3, tmp_list4, next);
		for (dim=0; dim < D; dim++) {
			copy(my_N, 1, xyz_int[dim], 1, tmp_list4);
			replace(xyz_int[dim], my_N, tmp_list3, tmp_list4, next);
		}
		un_numbered_N = last;
		for (i=0; i < my_N; i++)
			tmp_list4[tmp_list3[i]] = i;
}
replace(list1, size, indices, buffer, needed)      
int	*list1, size, *indices, *buffer, needed;
{
		int i, next;
		for (i=next=0;  i <size; i++)
				list1[next++] = buffer[indices[i]];
}/*end replace*/	
		
modify_row_col(size, row_col,  tmp_list4)
int	size, *row_col, *tmp_list4;
{
		int i, j;
		for (i=0; i < size; i++){
			j = row_col[i];
			row_col[i] = tmp_list4[j];
		}
}
free_d_all()
{
		int i;
                for (i =0; i <D; i++) {
                        free (((char *) xyz_int[i]));
                        free (((char *) xyz[i]));
                }

		free_other_lists(1);
		free_items();
		free(((char *) scratch_list));
		P = old_P;
}
free_damn_all()
{
		int i;
                for (i =0; i <D; i++) {
                        free (((char *) xyz_int[i]));
                        free (((char *) xyz[i]));
                }

		free_other_lists(1);
		free_items();
}
free_all()
{

                int i;
		for (i =0; i <D; i++) {
				free (((char *) xyz_int[i]));

														free (((char *) xyz[i]));
												}

														free_other_lists(1);
																free_items();


		free(((char *) scratch_list));
		P = old_P;
}
