/*---------------------------------------------------------------*/
/*     	CAPSS: A Cartesian Parallel Sparse Solver                */
/*     	Beta Release                                             */
/*      Author: Padma Raghavan                                   */
/*---------------------------------------------------------------*/
#include	"o_lists.h"
set_up_lists(file_name, memory_param)
char		*file_name;
float		memory_param;
{
/*
 * some of the etc of order_etc
 *
 */
		int i;
		double  last_clock;
		extern	double clock0(), stats[];
		extern		my_N;


		for (i=0; i <MAX_STATS; i++)
			stats[i] =0.0;
                if (my_pid ==0)
                        printf("\n...reading in data\n",my_pid);

		get_specs(file_name);

		allocate_nonz_coord_space();

		get_data(file_name, FLOAT);
		
		sync0();
                if (my_pid ==0)
                        printf("\n...initializing\n",my_pid);
		last_clock = clock0();

		make_items();
		initialize_lists(memory_param);
		last_used_in_scratch_list = 
				last_used_in_d_scratch_list =0;

		for (i= max_size_scratch_list =0; i <D; i++)
			if(max_size_scratch_list <
			 max_size_kappa_counts[i]) max_size_scratch_list
				= max_size_kappa_counts[i];
		if (P >1) {
				max_size_scratch_list *= 3*memory_param;
				l_phase =0;
				d_phase =1;
		} else { d_phase =0;
			 l_phase =1;
		}
                if((scratch_list = (int *) 
			my_malloc((max_size_scratch_list*int_size))) == NULL)
                         exit_err("main_scratch_list", malloc_err);

		stats[i_t] = clock0() - last_clock;
		stats[A_nz] = Asubs;
		stats[A_cols] = my_N;
		for (i=0; ((1<<i) < Asubs); ) i++;
		stats[i_o]  += (D * Asubs + D *my_N) *i;
		stats[i_o]  /= Million;
}
initialize_tree_stuff()
{
	last_chain_index= my_graph_number= start_numbers[0] = tree_size =0;
	if (P >1) {
			start_proc= start_procs[0]=tree_start_procs[0]= 0;
			count_proc=count_procs[0]=tree_count_procs[0]= P;
			end_proc = tree_end_procs[0]=P-1;
			parent_number = -1;
	}
	else  	parent_number =0;
	max_graphs=1;
	end_numbers[0] = g_N-1;
	tree_parent[0] = -1;
	last_color =1;
}
	
initialize_lists(memory_param) 
float	memory_param;
{

	if (P>1){
		d_phase_lists(memory_param);
		set_up_neighbors(my_pid, P, my_neighbors, processor_list);
	}
	old_P = P;
	other_lists();
	seps_lists(N, M);
	initialize_tree_stuff();
}
d_phase_lists (memory_param)
float	memory_param;
{
/*d_phase stuff */
	int i, dim, size1, sizep,max_lvls;
	if((region_limits = (int *)
			my_malloc((D*2*(P+1)*int_size))) == NULL)
			exit_err("d_phase_lists1", malloc_err);
		
	for (dim=max_lvls=0; dim <D; dim++){
		region_limits[2*dim] = *(block_labels[dim] );;
		region_limits[2*dim+1] = *(block_labels[dim] + P);
		max_levels[dim] = *(block_labels[dim] +my_pid+1) - 
				*(block_labels[dim] + my_pid);
		if (max_levels[dim] > max_lvls) max_lvls = 
					max_levels[dim];
	}
	for (log_2_P=0; ((1<< log_2_P) < P); )
				 log_2_P++;
	d_tree_next = log_2_P -1;
	if (max_lvls ==0)
			exit_err("d_phase_lists0:max_lvls", case_err);
	size1 = 4*(Asubs+1) > (4*N)? 4*(Asubs+1): 4*N; 
	size1 *= 3;
	if (P > 16)
	trial_and_err(((int) (2*size1*memory_param)));
	else 
	trial_and_err(((int) (size1*memory_param)));
	if((col_map = (int *)
			my_malloc((N *int_size))) == NULL)
			exit_err("d_phase_lists2", malloc_err);
	set_to(col_map,N,EMPTY);
	if((edge_map = (int *)
			my_malloc((Asubs*int_size))) == NULL)
			exit_err("d_phase_lists3", malloc_err);
	set_to(edge_map,Asubs,EMPTY);
	if((start_procs = (int *)
			my_malloc((2*P*int_size))) == NULL)
			exit_err("d_phase_lists4", malloc_err);
	if((count_procs = (int *)
			my_malloc((2*P*int_size))) == NULL)
			exit_err("d_phase_lists5", malloc_err);
	if((tree_start_procs = (int *)
			my_malloc((2*P*int_size))) == NULL)
			exit_err("d_phase_lists6", malloc_err);
	if((tree_count_procs = (int *)
			my_malloc((2*P*int_size))) == NULL)
			exit_err("d_phase_lists7", malloc_err);
	if((tree_end_procs = (int *)
			my_malloc((2*P*int_size))) == NULL)
			exit_err("d_phase_lists8", malloc_err);
	if((processor_list = (int *)
			my_malloc((P*int_size))) == NULL)
			exit_err("d_phase_lists11", malloc_err);
	if((my_neighbors = (int *)
			my_malloc((P*int_size))) == NULL)
			exit_err("d_phase_lists12", malloc_err);
	if((more = (int *)
			my_malloc((P*int_size))) == NULL)
			exit_err("d_phase_lists13", malloc_err);
	if((pad_list = (int *)
			my_malloc(((P+1)*int_size))) == NULL)
			exit_err("d_phase_lists14", malloc_err);
	for (i=0; i <P; i++) {
				processor_list[i] =i;
				pad_list[i] =0;
	}
	if((d_graph_seps_list = (int *)
			my_malloc((3*(P+1)*int_size))) == NULL)
			exit_err("d_phase_lists13", malloc_err);

	max_blocks = P;
}/*d_phase_lists */
other_lists()
{
	int	dim, size1, sizep, max_lvls;

	if (P==1){
	for (max_lvls = *(limits[0]+1), dim=1; dim < D; dim ++)
		if ((*(limits[dim] +1)) > max_lvls)
			max_lvls = *(limits[dim] +1);
	}
	else{
		for (dim=max_lvls=0; dim <D; dim++){
		max_levels[dim] = *(block_labels[dim] +my_pid+1) - 
				*(block_labels[dim] + my_pid);
		if (max_levels[dim] > max_lvls) max_lvls = 
					max_levels[dim];
		}
	}

	for (dim=0; dim <D; dim++){

		size1 = 4*(N+1) + 2* (* (limits[dim] +1)) ;
		size1 *=2; 
		if (P >1)
		if((vtx_counts[dim] = (int *)
			my_malloc((size1*int_size))) == NULL)
			exit_err("other_lists1", malloc_err);
		max_size_vtx_counts[dim] = size1;

		size1 = 4*(Asubs+1) + 2* ( *(limits[dim] +1)) ;
		size1 *=2; 
/*
		if (P>1) {
		sizep = max_levels[dim]*4*(P+3) ;
		size1 = (sizep > size1) ? sizep: size1;
		}
*/
		if (P >1)
		if((kappa_counts[dim] = (int *)
			my_malloc((size1*int_size))) == NULL)
			exit_err("other_lists2", malloc_err);

		max_size_kappa_counts[dim] = size1;
	}
	if (P ==1) {
		for (size1=dim=0; dim <D; dim++)
		if (size1 < max_size_vtx_counts[dim])
			size1= max_size_vtx_counts[dim];
		if((vtx_counts[0] = (int *)
			my_malloc((size1*int_size))) == NULL)
			exit_err("other_lists1", malloc_err);
		max_size_vtx_counts[0] = size1;
		for (size1=dim=0; dim <D; dim++)
		if (size1 < max_size_kappa_counts[dim])
			size1= max_size_kappa_counts[dim];
		if((kappa_counts[0] = (int *)
			my_malloc((size1*int_size))) == NULL)
			exit_err("other_lists2", malloc_err);
		max_size_kappa_counts[0] = size1;
	}

	size1 = 4*(Asubs+1) + 2* (max_lvls) ;
	if (P>1) size1 *=4;
	else size1 *=2;
	if (P>1) {
		sizep = max_lvls*5*(P+3) ;
		size1 = (sizep > size1) ? sizep: size1;
	}
	if((beta_counts = (int *)
			my_malloc((size1*int_size))) == NULL)
			exit_err("other_lists3", malloc_err);
	max_size_beta_counts = size1;

	if((eps_counts = (int *)
			my_malloc((size1*int_size))) == NULL)
			exit_err("other_lists4", malloc_err);
	max_size_eps_counts = size1;
	if ( P >1) {
	if((graph_bounds = (int *)
			my_malloc((3*(P+1)*int_size))) == NULL)
			exit_err("other_lists5", malloc_err);
	}
	else 
	if((graph_bounds = (int *)
			my_malloc((3*(N+1)*int_size))) == NULL)
			exit_err("other_lists5", malloc_err);

	if (P >1){
	if((graph_seps_list_ce = (int *)
			my_malloc((3*(P+1)*int_size))) == NULL)
			exit_err("other_lists6", malloc_err);
	}
	else 
	if((graph_seps_list_ce = (int *)
			my_malloc((3*(N+1)*int_size))) == NULL)
			exit_err("other_lists6", malloc_err);
	if (P ==1) l_graph_seps_list =
			 graph_seps_list_v = graph_seps_list_ce;
	else
	if((graph_seps_list_v = (int *)
			my_malloc((3*(P+1)*int_size))) == NULL)
			exit_err("other_lists7", malloc_err);

	if (P >1){
	if((total_graph_count = (int *)
			my_malloc((3*(P+1)*int_size))) == NULL)
			exit_err("other_lists8", malloc_err);
	}
	else
	if((total_graph_count = (int *)
			my_malloc((3*(N+1)*int_size))) == NULL)
			exit_err("other_lists8", malloc_err);

	if((in_graph_v = (int *)
			my_malloc((N*int_size))) == NULL)
			exit_err("other_lists9", malloc_err);
	if((deleted_v = (int *)
			my_malloc((N*int_size))) == NULL)
			exit_err("other_lists10", malloc_err);
	set_to(deleted_v,N,0);
	set_to(in_graph_v,N,0);

	if (T== SYMM) {
	if((in_graph_ce = (int *) 
			my_malloc((Asubs*int_size))) == NULL)
			exit_err("other_lists11", malloc_err);
	set_to(in_graph_ce,Asubs,0);
	}
	else exit_err("other_lists: T not SYMM", case_err);
}/*other_lists*/

trial_and_err(size1)
int size1;
{
	if((r_vector = (int *)
			my_malloc((3*size1*int_size))) == NULL)
			exit_err("d_phase_lists9", malloc_err);
	max_size_r_vector = 3*size1;
	if((s_vector = (int *)
			my_malloc((3*size1*int_size))) == NULL)
			exit_err("d_phase_lists10", malloc_err);
	max_size_s_vector = 3*size1;
	if((k_vector = (int *)
			my_malloc((3*size1*int_size))) == NULL)
			exit_err("d_phase_lists11", malloc_err);
	max_size_k_vector = 3*size1;
        if((d_scratch_list = (int *) my_malloc
				((5*size1*int_size))) == NULL)
                        exit_err("d_scratch_list:can't alloc",malloc_err);
	max_size_d_scratch_list = 5*size1;
}
